/* ml-interrupt.h
 *
 */

#ifndef _ML_INTERRUPT_
#define _ML_INTERRUPT_
#include <signal.h>

typedef struct pending_int{	/* an item in the pending interrupt queue */
    int		IntNum; 	/* the ID number of the pending interrupt */
    struct pending_int *next;	
} pending_int_t;

/* The state of ML interrupt handlers; these definitions must agree with
 * the values used in interrupts.sml.
 */
#define ML_INT_UNABLED		0
#define ML_INT_ENABLED		1

#define SIG_INTERRUPT		SIGUSR2     /* 4 = user2 signal */

/** Utility functions **/
extern int ChooseInterrupt (ml_state_t *msp);
extern void EnqueueInterrupt (vproc_state_t *vsp, int IntID);
extern void DequeueInterrupt (vproc_state_t *vsp);

/*
extern ml_val_t MakeResumeCont (ml_state_t *msp, ml_val_t resume[]);
extern ml_val_t MakeHandlerArg (ml_state_t *msp, ml_val_t resume[]);
extern void LoadResumeState (ml_state_t *msp);
extern bool_t GCSignal (vproc_state_t *vsp);
*/

#endif /* !_ML_INTERRUPT_ */
