(* structure for timer interrupt handler **)

structure Timer : TIMER = struct 
  val TIMER_IRQ = 0
  val jiffies = ref 0
  
  exception INVALID_INTERRUPT

  fun interrupt(id) = (
      if id <> TIMER_IRQ
      then raise INVALID_INTERRUPT	
      else jiffies := !jiffies + 1
  )     
  
  fun gettime() = !jiffies

  fun init() = 
      let val h = DevInt.INSTALLED interrupt
      in  DevInt.setHandler(TIMER_IRQ, h, DevInt.TIMER_PRIORITY, "TIMER");
	  jiffies := 0
      end     
  

end 
