(*

	FoxNet: The Fox Project's Communication Protocol Implementation Effort
	Edoardo Biagioni (Edoardo.Biagioni@cs.cmu.edu)
	Brian Milnes (Brian.Milnes@cs.cmu.edu)
	Ken Cline (Kenneth.Cline@cs.cmu.edu)
        Chris Stone (stone+@cmu.edu)
	Fox Project
	School of Computer Science
	Carnegie Mellon University
	Pittsburgh, Pa 15213-3891

		i.	Abstract



		ii.	Table of Contents

	i.	Abstract
	ii.	Table of Contents
	iii.	RCS Log
	1.	signature SERVER

		iii.	RCS Log
	
$Log: httpd.sig,v $
Revision 1.6  1996/06/07  20:24:59  cline
added inetd service interface

Revision 1.5  1996/05/13  16:16:43  cstone
Added back install_fn

Revision 1.4  1996/03/02  18:17:37  cstone
Updated to new foxnet

Revision 1.3  1995/09/29  15:25:51  cstone
Initial signature for new-protocol-signature httpd

# Revision 1.2  1995/03/08  20:23:28  cstone
# Added functions to get server statistics.
#

*)

(*
------------------------------------------------------------------------
		1.	signature SERVER
*)

signature HTTPD =
sig
    val run_httpd       : unit -> unit

    val uptime          : unit -> int
    val bytesout        : unit -> Word64.word
    val accesses        : unit -> int

    val install_fn      : string -> (unit -> string) -> unit

    structure Transport : PROTOCOL
    val inetd_handler   : Transport.handler
end
