(*

	FoxNet: The Fox Project's Communication Protocol Implementation Effort
	Edoardo Biagioni (Edoardo.Biagioni@cs.cmu.edu)
	Brian Milnes (Brian.Milnes@cs.cmu.edu)
	Ken Cline (Kenneth.Cline@cs.cmu.edu)
        Nick Haines (Nick.Haines@cs.cmu.edu)
	Fox Project
	School of Computer Science
	Carnegie Mellon University
	Pittsburgh, Pa 15139-3891

		i.	Abstract

	Support for parsing and viewing locatives.

	Given a description of what is wanted, bytes to view (in the
	form of a ubyte1 flat_vector), forge parses the bytes, builds
	a descriptor, and locviews the data.  This is type unsafe and
	ugly, but necessary in order to use current flat data.


		ii.	Table of Contents

	i.	Abstract
	ii.	Table of Contents
	iii.	RCS Log
	1.	signature FORGE

		iii.	RCS Log
	
$Log: forge.sig,v $
Revision 1.1  1993/12/21  17:15:18  cline
Initial revision



		1.	signature FORGE
*)

signature FORGE =
sig

   (* Raise forge_desc when the data can't be parsed as described *)
   exception Forge_Desc

  datatype forge_desc =
      Forge_Byte1
    | Forge_Byte2
    | Forge_Byte4
    | Forge_Byte2u		(* unaligned *)
    | Forge_Byte4u		(* unaligned *)
    | Forge_Tuple of forge_desc list
				(* tuple of listed forge_descs *)
    | Forge_Vector of descriptor
				(* vector containing the rest of the data *)
    | Forge_Vector_Length of descriptor*int
				(* vector of n bytes *)
    | Forge_CString
				(* null terminated ubyte1 flat_vector *)

  val forge: forge_desc -> ubyte1 flat_vector locative -> 'a locative

end
