(*

	FoxNet: The Fox Project's Communication Protocol Implementation Effort
	Edoardo Biagioni (Edoardo.Biagioni@cs.cmu.edu)
	Brian Milnes (Brian.Milnes@cs.cmu.edu)
	Ken Cline (Kenneth.Cline@cs.cmu.edu)
        Nick Haines (Nick.Haines@cs.cmu.edu)
	Fox Project
	School of Computer Science
	Carnegie Mellon University
	Pittsburgh, Pa 15139-3891

		i.	Abstract

Parsing support for Kerberos names.


		ii.	Table of Contents

	i.	Abstract
	ii.	Table of Contents
	iii.	RCS Log
	1.	functor Kname_Parse

		iii.	RCS Log
	
$Log: kname_parse.fun,v $
Revision 1.2  1994/05/24  14:29:49  robby
Ken's restructuring following a code review.

Revision 1.1  1993/12/14  21:49:28  cline
Initial revision


		1.	functor Kname_Parse
*)

functor Kname_Parse(structure B        : FOX_BASIS
                    structure Protocol : KRB_PROTOCOL
                    sharing type Protocol.name     = string
                        and type Protocol.instance = string
                        and type Protocol.realm    = string): KNAME_PARSE =
struct
  type principal = Protocol.principal

  fun split_at (c, s) =
      case B.V.String.index (c, s, 0) of
        SOME k => (B.V.String.substring (s, 0, k),
                   B.V.String.substring (s, k+1, (size s) - (k+1)))
      | NONE => (s, "")

  fun parse kname =
      let
        val (name_instance, realm) = split_at ("@",kname)
        val (name, instance)       = split_at (".",name_instance)
      in
        Protocol.Principal {name=name, instance=instance, realm=realm}
      end
end (* functor Kname_Parse *)
