(*

	FoxNet: The Fox Project's Communication Protocol Implementation Effort
	Edoardo Biagioni (Edoardo.Biagioni@cs.cmu.edu)
	Brian Milnes (Brian.Milnes@cs.cmu.edu)
	Ken Cline (Kenneth.Cline@cs.cmu.edu)
        Nick Haines (Nick.Haines@cs.cmu.edu)
	Fox Project
	School of Computer Science
	Carnegie Mellon University
	Pittsburgh, Pa 15139-3891

		i.	Abstract

Miscellaneous functions for Kerberos and DES


		ii.	Table of Contents

	i.	Abstract
	ii.	Table of Contents
	iii.	RCS Log
	1.	signature KRB_UTIL

		iii.	RCS Log
	
$Log: krbutil.sig,v $
Revision 1.2  1994/05/24  14:33:39  robby
 Ken's restructuring following a code review.

Revision 1.1  1993/12/14  21:10:43  cline
Initial revision


		1.	signature KRB_UTIL
 *)

signature KRB_UTIL =
sig
  type principal       (* shared with Krb_Protocol *)
  type local_principal (* shared with Krb_Protocol *)
  type credential      (* shared with Krb_Protocol *)

  val get_tgticket: {principal : principal,
                     service   : local_principal,
                     life      : ubyte1}
                    -> credential

  val request:{ principal : principal,
                service   : local_principal,
                srealm    : string,    (* server's realm *)
                checksum:ubyte4,       (* optional checksum *)
                lifetime:ubyte4,
                tg_credential: credential }
              -> credential
end
