(*

	FoxNet: The Fox Project's Communication Protocol Implementation Effort
	Edoardo Biagioni (Edoardo.Biagioni@cs.cmu.edu)
	Brian Milnes (Brian.Milnes@cs.cmu.edu)
	Ken Cline (Kenneth.Cline@cs.cmu.edu)
        Nick Haines (Nick.Haines@cs.cmu.edu)
	Fox Project
	School of Computer Science
	Carnegie Mellon University
	Pittsburgh, Pa 15139-3891

		i.	Abstract

	Byte swapping functions.


		ii.	Table of Contents

	i.	Abstract
	ii.	Table of Contents
	iii.	RCS Log
	1.	functor Swap_Bytes

		iii.	RCS Log
	
$Log: swap.fun,v $
Revision 1.1  1994/05/20  02:25:06  robby
Initial revision



		1.	functor Swap_Bytes
*)

functor Swap_Bytes() : SWAP_BYTES =
struct

  (* inefficient implementation *)
  local
    infix && || << >>
  in
    fun swap_ubyte4 (x:Byte4.ubytes) =
      ((x && 4ux000000FF) << 24) ||
      ((x && 4ux0000FF00) << 8 ) ||
      ((x && 4ux00FF0000) >> 8 ) ||
      ((x && 4uxFF000000) >> 24)

    fun swap_ubyte2 (x:Byte2.ubytes) =
      ((x && 2ux00FF) << 8 ) || ((x && 2uxFF00) >> 8 )
  end

  val do_swap = {swap_ubyte4 = swap_ubyte4,
                   swap_ubyte2 = swap_ubyte2}

  fun id x = x

  val no_swap = {swap_ubyte4 = id,
                 swap_ubyte2 = id}
end
