(*

	FoxNet: The Fox Project's Communication Protocol Implementation Effort
	Edoardo Biagioni (esb@cs.cmu.edu)
	Ken Cline (Kenneth.Cline@cs.cmu.edu)
	Brian Milnes (Brian.Milnes@cs.cmu.edu)
        Nick Haines (Nick.Haines@cs.cmu.edu)
	Fox Project
	School of Computer Science
	Carnegie Mellon University
	Pittsburgh, Pa 15213-3891

		i.	Abstract



		ii.	Table of Contents

	i.	Abstract
	ii.	Table of Contents
	iii.	RCS Log
	iv.	Overview
	1.	signature EXTERNAL

		iii.	RCS Log
	
$Log: external.sig,v $
# Revision 1.1  1995/06/20  17:31:02  esb
# Initial revision
#

		iv.	Overview

This signature is for a module that provides an abstract data type for
storing "external" data.  The data is external in the following ways:

- it is byte-indexed

- conversion to/from (scattered) byte arrays takes constant time and
  the resulting value shares with the argument: a change made to the
  argument modifies the result and vice-versa.

- sub, join, and split preserve sharing: that is, a modification
  made to the argument changes the result and vice-versa


		1.	signature EXTERNAL
*)

signature RESTRICTION_ARRAY =
 sig
  type T

  val new: ByteArray.bytearray -> T
  val size: T -> int			(* size in bytes *)
  val read: T -> ByteArray.bytearray	(* may create the result and copy *)
  exception Split_Array
  val read_raw: T -> ByteArray.bytearray (* may raise Split_Array *)

  datatype array8 = Nil8 | Cons8 of FoxWord8 * T
  val head8: T -> array8
  val update8: T * FoxWord8 -> unit

  datatype array16 = Nil16 | Cons16 of FoxWord16 * T
  val head16: T -> array16
  val update16: T * FoxWord16 -> unit

  datatype array32 = Nil32 | Cons32 of FoxWord32 * T
  val head32: T -> array32
  val update32: T * FoxWord16 -> unit

 end (* sig *)

