(*

	FoxNet: The Fox Project's Communication Protocol Implementation Effort
	Brian Milnes (Brian.Milnes@cs.cmu.edu)
	Nick Haines  (Nick.Haines@cs.cmu.edu)
	Edoardo Biagioni <Edoardo.Biagioni@cs.cmu.edu>
	Fox Project
	School of Computer Science
	Carnegie Mellon University
	Pittsburgh, Pa 15139-3891

		i.	Abstract

	cache.sig: signature CACHE.

		ii.	Table of Contents

	i.	Abstract
	ii.	Table of Contents
	iii.	RCS Log
	1.	signature SINGLE_CACHE

		iii.	RCS Log
	
$Log:	cache.sig,v $
Revision 1.1  97/04/17  14:06:20  esb
Initial revision


		1.	signature SINGLE_CACHE

	This is a signle imperative, monomorphic cache.
*)

signature SINGLE_CACHE =
 sig
  type key
  type value
  type space = int

(* Insufficient_Space is raised by add when the value is too large to
   fit in the space allocated for the cache.  Note that if the value
   can be stored by flushing older items from the cache, flushing
   takes place instead of the exception being raised. *)
  exception Insufficient_Space
  val add: key * value * space -> unit

  val look: key -> value option

  val remove: key -> unit

  val flush: unit -> unit

  (* app and fold are defined by analogy with the list operations *)
  val app: (key * value -> 'a) -> unit

  val fold: ((key * value) * 'a -> 'a) -> 'a -> 'a

  val makestring: ((key * value) -> string) * string (* separator *) -> string

 end
