(* structure for pc assembly interface *)

structure ASM = struct
	val getID:(unit -> int) = Unsafe.CInterface.c_function "PC-ASM" "getID";
	val sti:(unit -> unit) = Unsafe.CInterface.c_function "PC-ASM" "sti";
	val cli:(unit -> unit) = Unsafe.CInterface.c_function "PC-ASM" "cli";
	val inb:(int -> int ) = Unsafe.CInterface.c_function "PC-ASM" "inb";
	val inb_p:(int -> int) = Unsafe.CInterface.c_function "PC-ASM" "inb_p";
	val outb:((int*int) -> unit) = Unsafe.CInterface.c_function "PC-ASM" "outb";
	val outb_p:((int*int) -> unit) = Unsafe.CInterface.c_function "PC-ASM" "outb_p";
	val set_bit: ((int * word)-> int ) = Unsafe.CInterface.c_function "PC-ASM" "set_bit";  (* bit*address *)
	val clear_bit: ((int* word)-> int ) = Unsafe.CInterface.c_function "PC-ASM" "clear_bit";
	val inw:(int -> int ) = Unsafe.CInterface.c_function "PC-ASM" "inw";
	val outw:((int*int) -> unit) = Unsafe.CInterface.c_function "PC-ASM" "outw";
	val insw:((int*Word32.word*int) -> unit) = Unsafe.CInterface.c_function "PC-ASM" "insw";
	val outsw:((int*Word32.word*int) -> unit) = Unsafe.CInterface.c_function "PC-ASM" "outsw";
	val inw_p:(int -> int ) = Unsafe.CInterface.c_function "PC-ASM" "inw_p"; 
	val outw_p:((int*int) -> unit) = Unsafe.CInterface.c_function "PC-ASM" "outw_p";
	val request_region:(int*int*string)->unit = Unsafe.CInterface.c_function "PC-ASM" "request_region";
	val release_region:(int*int)->unit = Unsafe.CInterface.c_function "PC-ASM" "release_region";
	val request_irq:(int*int*string)->int = Unsafe.CInterface.c_function "PC-ASM" "request_irq";
	val free_irq: int->unit = Unsafe.CInterface.c_function "PC-ASM" "free_irq";


end


